function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

import React from 'react';
import { AssetTiming } from "../types.mjs";
export var EFFECT_ID = Symbol('react-async');
export var AsyncAssetManager = /*#__PURE__*/function () {
  function AsyncAssetManager() {
    var _this = this;

    _classCallCheck(this, AsyncAssetManager);

    this.effect = {
      id: EFFECT_ID,
      betweenEachPass: function betweenEachPass() {
        _this.assets.clear();
      }
    };
    this.assets = new Map();
  }

  _createClass(AsyncAssetManager, [{
    key: "used",
    value: function used() {
      var timing = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : AssetTiming.Immediate;
      var timingArray = Array.isArray(timing) ? timing : [timing];
      var assets = [];

      var _iterator = _createForOfIteratorHelper(this.assets),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var _step$value = _slicedToArray(_step.value, 2),
              asset = _step$value[0],
              _step$value$ = _step$value[1],
              scripts = _step$value$.scripts,
              styles = _step$value$.styles;

          var scriptsMatch = timingArray.includes(scripts);
          var stylesMatch = timingArray.includes(styles);

          if (stylesMatch || scriptsMatch) {
            assets.push({
              id: asset,
              scripts: scriptsMatch,
              styles: stylesMatch
            });
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      return assets;
    }
  }, {
    key: "markAsUsed",
    value: function markAsUsed(id) {
      var timing = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : AssetTiming.Immediate;
      var current = this.assets.get(id);
      var scripts = _typeof(timing) === 'object' ? timing.scripts : timing;
      var styles = _typeof(timing) === 'object' ? timing.styles : timing;

      if (current == null) {
        this.assets.set(id, {
          scripts: scripts || AssetTiming.Immediate,
          styles: styles || AssetTiming.Immediate
        });
      } else {
        this.assets.set(id, {
          // the AssetTiming enum has values where the smallest value is
          // the lowest importance load, and the highest value is for assets
          // needed immediately. So, when a new asset comes in that has
          // already been recorded, we can take the maximum value to
          // keep only the highest priority timing for the asset.
          scripts: Math.max(scripts || current.scripts, current.styles),
          styles: Math.max(styles || current.styles, current.styles)
        });
      }
    }
  }]);

  return AsyncAssetManager;
}();
export var AsyncAssetContext = /*#__PURE__*/React.createContext(null);