import React from 'react';
import { PrefetchContext } from './context/prefetch';
class ConnectedPrefetchRoute extends React.Component {
    componentDidMount() {
        const { manager, path, render } = this.props;
        this.unregister = manager.register({
            path,
            render,
        });
    }
    componentWillUnmount() {
        if (this.unregister) {
            this.unregister();
        }
    }
    render() {
        return null;
    }
}
export function PrefetchRoute(props) {
    return (React.createElement(PrefetchContext.Consumer, null, manager => (React.createElement(ConnectedPrefetchRoute, Object.assign({ manager: manager }, props)))));
}
