import React from 'react';
import { extract } from '@shopify/react-effect/server';
import { AsyncAssetManager, AsyncAssetContext } from './context/assets';
export async function getUsedAssets(element, ...args) {
    const asyncAssets = new AsyncAssetManager();
    await extract(element, {
        decorate: element => (React.createElement(AsyncAssetContext.Provider, { value: asyncAssets }, element)),
    });
    return asyncAssets.used(...args);
}
